> For the complete documentation index, see [llms.txt](https://docs.kpnthings.com/kpn-things/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kpnthings.com/kpn-things/building-blocks/devices/trackers/streamline-lora.md).

# Streamline LoRa

![Streamline LoRa](https://portal.kpnthings.com/assets/images/device-types/supported-streamline-lora.png)

For all Streamline LoRa devices (N1C2, P1A3, P1A5).

* Supported network type(s): `KPNLORA`
* Device Specification ID: `supported-streamline-lora`
* Device Specification UUID: `413e431d-4b9f-4266-93df-0b0662041b18`

| Decoders                               | decoderSpecificationUUID               | Description                                                                                    |
| -------------------------------------- | -------------------------------------- | ---------------------------------------------------------------------------------------------- |
| = Raw LoRa payload (v2)                | `ec596df3-4f12-5326-b72f-94f6da47e593` | Forward the raw LoRa payload and port number without decoding.                                 |
| › Decoded Streamline LoRa payload (v2) | `79a912f8-9b60-5a62-9c6e-85763801d746` | Decoder for Streamline LoRa message types 0x21, 0x22, 0x23, 0x24, and 0xFF, excluding IO bits. |

| Encoders           | encoderSpecificationUUID               | Description                           |
| ------------------ | -------------------------------------- | ------------------------------------- |
| = Raw LoRa payload | `36abf4ba-ed32-4069-8351-2426bc41a26b` | Send raw LoRa payload to your device. |

### = Raw LoRa payload (v2)

Forward the raw LoRa payload and port number without decoding.

{% hint style="info" %}
This decoder also decodes [Geolocation and Local Gateway](/kpn-things/getting-started/tutorials/technical-overview/location-data.md) data.
{% endhint %}

The following SenML records can be present, amongst others:

| name    | type   | unit | example                    | description                            |
| ------- | ------ | ---- | -------------------------- | -------------------------------------- |
| payload | string |      | `"4D985C495AC4D8C9682CFD"` | The LoRa hex payload                   |
| port    | number |      | `200`                      | The LoRa port used to send this uplink |

#### Example SenML

{% hint style="info" %}
SenML can be structured in different ways, and we do not guarantee the examples below will look the same as what you will receive on your Destination. To make sure you can handle the SenML optimally, take a look at our documentation about [Understanding and Interpreting SenML Data](/kpn-things/building-blocks/data-processing/thingsml-and-senml/senml/understanding-and-interpreting-senml-data.md).
{% endhint %}

```json
[
    {
        "bn": "urn:dev:DEVEUI:0123456789012345:",
        "bt": 1693136532.83,
        "n": "payload",
        "vs": "4D985C495AC4D8C9682CFD"
    },
    {
        "n": "port",
        "v": 1
    },
    {
        "n": "timeOrigin",
        "vs": "NETWORK"
    }
]
```

### › Decoded Streamline LoRa payload (v2)

Decoder for Streamline LoRa message types 0x21, 0x22, 0x23, 0x24, and 0xFF, excluding IO bits.

{% hint style="info" %}
This decoder also decodes [Geolocation and Local Gateway](/kpn-things/getting-started/tutorials/technical-overview/location-data.md) data.
{% endhint %}

The following SenML records can be present, amongst others:

| name           | type   | unit | example    | description                                |
| -------------- | ------ | ---- | ---------- | ------------------------------------------ |
| accelerationX  | number | m/s2 |            | Measured acceleration in the X-axis        |
| accelerationY  | number | m/s2 |            | Measured acceleration in the Y-axis        |
| accelerationZ  | number | m/s2 |            | Measured acceleration in the Z-axis        |
| batteryVoltage | number | V    |            | Measured battery voltage                   |
| compassX       | number | T    |            | Measured compass orientation in the X-axis |
| compassY       | number | T    |            | Measured compass orientation in the Y-axis |
| compassZ       | number | T    |            | Measured compass orientation in the Z-axis |
| heading        | number | rad  |            |                                            |
| latitude       | number | lat  | `51.90726` | Latitude                                   |
| longitude      | number | lon  | `4.48945`  | Longitude                                  |
| temperature    | number | Cel  |            |                                            |
| velocity       | number | m/s  |            |                                            |

#### Example SenML

{% hint style="info" %}
SenML can be structured in different ways, and we do not guarantee the examples below will look the same as what you will receive on your Destination. To make sure you can handle the SenML optimally, take a look at our documentation about [Understanding and Interpreting SenML Data](/kpn-things/building-blocks/data-processing/thingsml-and-senml/senml/understanding-and-interpreting-senml-data.md).
{% endhint %}

```json
[
    {
        "bn": "urn:dev:DEVEUI:03cce494b059a546:",
        "bt": 1701882708.84,
        "n": "longitude",
        "u": "lon",
        "v": 4.48940
    },
    {
        "n": "latitude",
        "u": "lat",
        "v": 51.90717
    },
    {
        "n": "velocity",
        "u": "m/s",
        "v": 4.12
    },
    {
        "n": "heading",
        "u": "rad",
        "v": -3.944
    },
    {
        "n": "accelerationX",
        "u": "m/s2",
        "v": 9.5002
    },
    {
        "n": "accelerationY",
        "u": "m/s2",
        "v": 0.7661
    },
    {
        "n": "accelerationZ",
        "u": "m/s2",
        "v": 0.1532
    },
    {
        "n": "compassX",
        "u": "T",
        "v": 0.000001
    },
    {
        "n": "compassY",
        "u": "T",
        "v": -0.001507
    },
    {
        "n": "compassZ",
        "u": "T",
        "v": -0.002638
    },
    {
        "n": "temperature",
        "u": "Cel",
        "v": 7
    },
    {
        "n": "batteryVoltage",
        "u": "V",
        "v": 3.59
    },
    {
        "n": "timeOrigin",
        "vs": "NETWORK"
    }
]
```

### = Raw LoRa payload encoding

* Protocol: LoRa downlink
* Description: Send raw LoRa payload to your device.
* Multiple commands in one downlink: No

Input mapping:

* Name: `payloadHex` (raw input)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.kpnthings.com/kpn-things/building-blocks/devices/trackers/streamline-lora.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
